
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>epoll 和 select 的区别 / 憋错料</title>

    <meta name="description" content="epoll 和 select 的区别 面试linux的时候,很多面试官都会问的一个问题是epoll和select的区别,而我总是答的不够完整,今天总结一下epoll和select的区别. 首先select是posix支持的,而epoll是linux特定的系统调用,因此,epoll的可移植性就没有select好,但是考虑到epoll和select一般用作服务器的比较多,而服务器中大多又是linux,所以这个可移植性的影响应该不会很大. 其次,select可以监听的文件描述符有限,最大值为1024,而epoll可以监听的文件描述符则是系">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">epoll 和 select 的区别</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>面试linux的时候，很多面试官都会问的一个问题是epoll和select的区别，而我总是答的不够完整，今天总结一下epoll和select的区别。</p>
<p>首先select是posix支持的，而epoll是linux特定的系统调用，因此，epoll的可移植性就没有select好，但是考虑到epoll和select一般用作服务器的比较多，而服务器中大多又是linux，所以这个可移植性的影响应该不会很大。</p>
<p>其次，select可以监听的文件描述符有限，最大&#20540;为1024，而epoll可以监听的文件描述符则是系统对整个进程限制的最大文件描述符。</p>
<p>接下来就要谈epoll和select的性能 比较了，这个一般情况下应该是epoll表现好一些，否则linux也不会去特定实现epoll函数了，那么epoll为什么比select更高效呢？原因有很多，第一点，epoll通过每次有就绪事件时都将其插入到一个就绪队列中，使得epoll_wait的返回结果中只存储了已经就绪的事件，而select则返回了所有被监听的事件，事件是否就绪需要应用程序去检测，那么如果已被监听但未就绪的事件较多的话，对性能的影响就比较大了。第二点，每一次调用select获得就绪事件时都要将需要监听的事件重复传递给操作系统内核，而epoll对监听文件描述符的处理则和获得就绪事件的调用分开，这样获得就绪事件的调用epoll_wait就不需要重新传递需要监听的事件列表，这种重复的传递需要监听的事件也是性能低下的原因之一。除此之外，epoll的实现中使用了mmap调用使得内核空间和用户空间共享内存，从而避免了过多的内核和用户空间的切换引起的开销。</p>
<p>然后就是epoll提供了两种工作模式，一种是水平触发模式，这种模式和select的触发方式是一样的，即只要文件描述符的缓冲区中有数据，就永远通知用户这个描述符是可读的，这种模式对block和noblock的描述符都支持，编程的难度也比较小 ；&nbsp;而另一种更高效且只有epoll提供的模式是边缘触发模式，只支持nonblock的文件描述符，他只有在文件描述符有新的监听事件发生的时候（例如有新的数据包到达）才会通知应用程序，在没有新的监听时间发生时，即使缓冲区有数据（即上一次没有读完，或者甚至没有读），epoll也不会继续通知应用程序，使用这种模式一般要求应用程序收到文件描述符读就绪通知时，要一直读数据直到收到EWOULDBLOCK/EAGAIN错误，即将缓冲区中的内容读完，否则有可能引起死等。这种模式虽然容易出错，但是性能要比前面的模式更高效，因为只需要监听是否有事件发生，发生了就直接将描述符加入就绪队列即可。</p>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 01:45:53 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/linux/" title="linux">linux</a>, <a href="https://www.biecuoliao.com/tag/select/" title="select">select</a>, <a href="https://www.biecuoliao.com/tag/c%e8%af%ad%e8%a8%80/" title="c语言">c语言</a>, <a href="https://www.biecuoliao.com/tag/posix/" title="posix">posix</a>, <a href="https://www.biecuoliao.com/tag/epoll/" title="epoll">epoll</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>epoll 和 select 的区别的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k9DyX4.html" rel="bookmark">epoll 和select 的区别，epoll和select的实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				epoll是Linux内核为处理高并发而作改进的poll,是Linux下多路复用IO接口select/poll的增强版本.这里主要讲epoll和另外两个的区别,另外再把epoll的一个简单运用实例说说. (一)epoll 有select,poll的主要区别: 一.相比于select与poll, epoll最大的好处在于它不会随着监听fd数目的增长而降低效率: 二.内核中的select与poll的实现是采用轮询来处理的,轮询的fd数据越多,自然耗时也越多: 三.epoll的实现是基于回调的,如果f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eY2rg0.html" rel="bookmark">&lbrack;转&rsqb;IO模型及select、poll、epoll和kqueue的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(一)首先,介绍几种常见的I/O模型及其区别,如下: blocking I/O nonblocking I/O I/O multiplexing (select and poll) signal driven I/O (SIGIO) asynchronous I/O (the POSIX aio_functions)—————异步IO模型最大的特点是 完成后发回通知. 阻塞与否,取决于实现IO交换的方式.      异步阻塞是基于select,select函数本身的实现方式是阻塞的,而采用sel			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEZNEX0.html" rel="bookmark">epoll和select区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先说下本文框架,先是问题引出,然后概括两个机制的区别和联系,最后介绍每个接口的用法 一.问题引出 联系区别 问题的引出,当需要读两个以上的I/O的时候,如果使用阻塞式的I/O,那么可能长时间的阻塞在一个描述符上面,另外的描述符虽然有数据但是不能读出来,这样实时性不能满足要求,大概的解决方案有以下几种: 1.使用多进程或者多线程,但是这种方法会造成程序的复杂,而且对与进程与线程的创建维护也需要很多的开销.(Apache服务器是用的子进程的方式,优点可以隔离用户) 2.用一个进程,但是使用非阻塞的I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38qpNZ4.html" rel="bookmark">epoll和poll、select的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://blog.csdn.net/jnu_simba/article/details/12523175 二.epoll与select.poll区别 1.相比于select与poll,epoll最大的好处在于它不会随着监听fd数目的增长而降低效率.内核中的select与poll的实现是采用轮询来处理的,轮询的fd数目越多,自然耗时越多. 2.epoll的实现是基于回调的,如果fd有期望的事件发生就通过回调函数将其加入epoll就绪队列中,也就是说它只关心&quot;活跃&quot;的fd,与fd数目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jG2Og3.html" rel="bookmark">Nginx之epoll和select poll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				epoll和 select poll 都是做I/O多路复用的. 区别在于: epoll较灵活,如果有一百万个链接状态同时保持,但是在某个时刻,只有几百个链接是活跃的.epoll的处理是通过epoll_create()创建对象,epoll_ctl()收集所有的套接字添加到epoll对象,epoll_wait()收集所有发生事件也就是所谓的活跃的链接,并收集到一个List链表中,这样只需要遍历这些List链表里的数据,而不用遍历一百万个链接. 而后者select poll则是每次收集事件时,将这一百			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bywgYM.html" rel="bookmark">非阻塞socket调用connect&comma; epoll和select检查连接情况示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				from http://www.cnblogs.com/yuxingfirst/archive/2013/03/08/2950281.html 我们知道,linux下socket编程有常见的几个系统调用: 对于服务器来说, 有socket(), bind(),listen(), accept(),read(),write() 对于客户端来说,有socket(),connect() 这里主要要讲的是客户端这边的connect函数. 对于客户端来说,需要打开一个套接字,然后与对端服务器连接,例如:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dzBRw4.html" rel="bookmark">epoll&sol;poll&sol;select的原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着2.6内核对epoll的完全支持,网络上很多的文章和示例代码都提供了这样一个信息:使用epoll代替传统的poll能给网络服务应用带来性能上的提升.但大多文章里关于性能提升的原因解释的较少,这里我将试分析一下内核(2.6.21.1)代码中poll与epoll的工作原理,然后再通过一些测试数据来对比具体效果.       POLL: 先说poll,poll或select为大部分Unix/Linux程序员所熟悉,这俩个东西原理类似,性能上也不存在明显差异,但select对所监控的文件描述符数量有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZAADd0.html" rel="bookmark">insert into&comma;&comma;&comma;select 和 select into&period;&period;&period;区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.insert into table1 (p1,p2..) select(p1,p2) from table2 从table2中查出数据然后在插入到table1中 ,table1和table2都是存在的已经定义好的表 2.select into table1(p1,p2..) from table2 将table2中的所有数据插入到table1中,table1是不存在的一张表,当使用时临时创建的,这种方式适合用于单表数据表备份			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pQz1KM.html" rel="bookmark">select into from 与insert into select from区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				select * into target_table from source_table; insert into target_table(col1, col2)select col1, 5 from source_table 相同点: 1.以上两句都是将源表source_table的记录插入到目标表target_table 不同点: 1.(select into from)要求目标表target_table不存在,因为在插入时会自动创建 (insert into select form)要求			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3q5YW3.html" rel="bookmark" class="title">iOS---代理与协议以及通知的使用</a>
					<div>
						一.代理 1.代理的介绍 代理是一种通用的设计模式 代理使用方式:A 让 B 做件事,空口无凭,签个协议. 所以代理有三部分组成: 委托方: 定义协议 协议   : 用来规定代理方可以做什么,必须做什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzQx84.html" rel="bookmark" class="title">android产品研发（七）--&amp;gt&semi;Apk热修复</a>
					<div>
						转载请标明出处:一片枫叶的专栏 去年一整年android社区中刮过了一阵热修复的风,各大厂商,逼格大牛纷纷开源了热修复框架,恩,产品过程中怎么可能没有bug呢?重新打包上线?成本太高用户体验也不好,咋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5rwN3.html" rel="bookmark" class="title">&lbrack;Hibernate&rsqb; - many to one</a>
					<div>
						Hibernate的多对一操作: 例子参考引用: http://www.tutorialspoint.com/hibernate/hibernate_many_to_one_mapping.htm h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEkZRx3.html" rel="bookmark" class="title">python接口测试</a>
					<div>
						上篇已经用mock server配置了接口. python代码编写接口测试,主要运用了unittest.requests两个框架 import json import unittest, reques ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8EPj0.html" rel="bookmark" class="title">HotSpot VM GC 的种类</a>
					<div>
						collector种类 GC在 HotSpot VM 5.0里有四种: incremental (sometimes called train) low pause collector已被废弃,不在介 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZA5Z80.html" rel="bookmark" class="title">linux命令之head、tail命令具体解释</a>
					<div>
						head 语法 样例 tail 语法 样例 head和tail组合使用方法举例 head 语法 head [-n -k ]... [FILE]... 样例 默认是显示开头前10行. head /etc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aAk8v0.html" rel="bookmark" class="title">Python之路 day2 按行读文件</a>
					<div>
						1 #1. 最基本的读文件方法: 2 3 # File: readline-example-1.py 4 5 file = open(&quot;sample.txt&quot;) 6 7 while ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvd2X3.html" rel="bookmark" class="title">在Windows2008上部署网站-以ACCESS 数据库的网站</a>
					<div>
						最近单位弄了几台新服务器. 配上了Windows2008 R2 64 位. (以前在虚拟机上玩过08,但是发现真机和虚拟机还是相差很大的) 小弟负责把原来的网站从03的系统上迁移到08 上 所以打算写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BwloM.html" rel="bookmark" class="title">4&period;C&num;WinForm基础图片&lpar;显示和隐藏&rpar;</a>
					<div>
						要求: 软件上有一张图片,默认是隐藏的.用户在文本框中输入身份证号(131226198105223452),点击按钮,如果年龄大于18岁,则显示图片. 知识点: 取当前年份,Date Time Now ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGmvwM.html" rel="bookmark" class="title">python logging模块配置方法浅析</a>
					<div>
						以下功能函数配置logging模块.它们位于logging.config模块中.它们的使用是可选的 - 可以使用这些功能函数配置logging模块:或者通过调用主API(logging中定义)并且定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAL6O4.html" rel="bookmark" class="title">在Eclipse中开发angularjs</a>
					<div>
						当然了,直接用Eclipse开发,完全没问题.我只是需要加个智能感知,安装一个Eclipse插件. Eclipse菜单-&gt;Help-&gt;Eclipse Marketplace 安装完以后,项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dN2J74.html" rel="bookmark" class="title">SQL Server 修改表结构后无法保存的老问题</a>
					<div>
						在修改表结构后无法保存,这是每次重装SQL Server后都会遇到的问题,好记性不如烂笔头,在这里记一下吧. 保存修改了的表结构时会提示“不允许保存更改.您所做的更改要求删除并重新创建以下表.您对无法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aYrWn0.html" rel="bookmark" class="title">PHPCMS v9修改默认后台登录地址</a>
					<div>
						使用开源程序建站,默认的后台路径很多时候都是被大家所知晓的,虽然一般人就算知道了后台登陆路径之后,没有账号密码也登陆不了,不过为了安全起见,还是有很多站长在选择修改后台的默认登陆路径,但是Phpcms ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDwrwM.html" rel="bookmark" class="title">小程序分析&lpar;fork&lpar;&rpar;和vfork&lpar;&rpar;&rpar;</a>
					<div>
						分析下述程序,i&lt;4时,最终创建了多少个进程. fork()是创建一个子进程. 分析:i=0时,父进程1创建了一个子进程1.(此时共2个进程) i=1时,父进程1继续创建子进程2,将子进程1又当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41DR7X3.html" rel="bookmark" class="title">成员函数的函数配接器</a>
					<div>
						在STL标准库中除了提供常规的函数配接器外,还提供了两个针对成员函数的函数配接器,其主要功能是通过这些配接器,你可以针对每一个元素直接去调用其成员函数. 这样的成员函数配接器有两个,分别是: mem_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ezAb4.html" rel="bookmark" class="title">获取当前日期</a>
					<div>
						这里要用到date函数的第三种形式,下面是获得当前日期 (set 'today (date (date-value) 0 &quot;%Y%m%d&quot;)) (date-value) 返回的是1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klo7j3.html" rel="bookmark" class="title">man 获取命令帮助</a>
					<div>
						最近发现MDT推出去的系统的有不同问题,其问题就不说了,主要是策略权限被域继承了.比如我们手动安装的很多东东都是未配置壮态,推的就默认为安全壮态了,今天细找了一下,原来把这个关了就可以了. man 获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rkxzj3.html" rel="bookmark" class="title">python基础之多线程</a>
					<div>
						概念 进程:进程就是一个程序在一个数据集上的一次动态执行过程 程序:代码 数据集:程序执行过程中需要的资源 进程控制块:完成状态保存的单元 线程:线程是寄托在进程之上,为了提高系统的并发性 线程是进程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38yAey4.html" rel="bookmark" class="title">Android各层推荐开发书籍及参考资料</a>
					<div>
						Android各层推荐开发书籍及参考资料 转自:http://blog.csdn.net/fancylovejava/article/details/8657058 Android系统按照架构来说一共 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02oVen3.html" rel="bookmark" class="title">Xcode 截取真机图片</a>
					<div>
						场景: 有时公司产品经理.设计师需要我们截取真机图片,这时我们常常会通过手机「Home+开机键」组合键来截取图片,然后通过 QQ 等通讯工具传输到电脑,接着再发送过去.当需要重复频繁操作时,就显得比较 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
